﻿using System;
using System.Collections.Generic;
using System.Text;

namespace opentkprojekt.Interpolation
{
    class NearestNeighborInterpolator : Interpolator
    {

        public KeyValuePair<KeyFraming.ObjectKeyFrame, KeyFraming.CameraKeyFrame> Interpolate(int time, ref KeyFraming.KeyFrameArray kfa)
        {
            int first = 0;
            int second = 0;
            kfa.FindKeyframesIndexes(time, out first, out second);
            int timeFirst = kfa.GetKeyframeTimeByIndex(first);
            int timeSecond = kfa.GetKeyframeTimeByIndex(second);
            double ratio = (double)(time - timeFirst) / (double)(timeSecond - timeFirst);
            if (Double.IsNaN(ratio)) { ratio = 0; }
            if (ratio < 0.5)
            {
                return kfa.GetKeyframeByIndex(first);
            }
            else
            {
                return kfa.GetKeyframeByIndex(second);
            }
        }


        public string InterpolatorName()
        {
            return "Najbližší sused";
        }
    }
}
