﻿using System;
using System.Collections.Generic;
using System.Text;

using OpenTK;

namespace opentkprojekt.KeyFraming
{
    class CameraKeyFrame
    {
        protected Vector3d position = new Vector3d(5.0f, 5.0f, 5.0f);
        protected Vector3d target = new Vector3d(0.0f, 0.0f, 0.0f);
        protected bool followTarget = true;

        public CameraKeyFrame(double pX, double pY, double pZ, double tX, double tY, double tZ)
        {
            followTarget = true;
            position = new Vector3d(pX, pY, pZ);
            target = new Vector3d(tX, tY, tZ);
        }

        public CameraKeyFrame(double pX, double pY, double pZ, bool follow)
        {
            followTarget = follow;
            position = new Vector3d(pX, pY, pZ);
            this.target = new Vector3d(0.0f, 0.0f, 0.0f);
        }

        public CameraKeyFrame()
        {

        }

        public void SetPosition(Vector3d position)
        {
            this.position.X = position.X;
            this.position.Y = position.Y;
            this.position.Z = position.Z;
        }

        public Vector3d GetPosition()
        {
            return new Vector3d(position);
        }

        public void SetTarget(Vector3d target)
        {
            this.target.X = target.X;
            this.target.Y = target.Y;
            this.target.Z = target.Z;
        }

        public Vector3d GetTarget()
        {
            return new Vector3d(target);
        }

        public void SetFollowTarget(bool follow)
        {
            this.followTarget = follow;
        }

        public bool GetFollowTarget()
        {
            return followTarget;
        }
    }
}
